﻿using System;
using System.Drawing;
using System.IO;
using System.Windows.Forms;
using BarcodeGenerationExample;
using IDAutomation.NetStandard.MaxiCode.FontEncoder;

namespace TestQR_GUI
{
    public partial class FullTest : Form
    {
        public FullTest()
        {
            InitializeComponent();
            cmbOutput.SelectedIndex = 1;
            cmbDotpMM.SelectedIndex = 2;
            cbEncoding.SelectedIndex = 0;
            txtQuietZone.Text = "1";
        }

        private void Form1_Load(object sender, EventArgs e)
        {
#if DEMO_VERSION
            frmDemo frm2 = new frmDemo();
            frm2.ShowDialog();
#endif
        }

        private void btUpdate_Click_1(object sender, EventArgs e)
        {


            string dataToEncode = tbDatatoencode.Text;
            bool applyTilde = ckApplyTilde.Checked;
            int QuietZone = int.Parse(txtQuietZone.Text);
            int DotPM = int.Parse(cmbDotpMM.Text);


            EncodingModes encodingMode = EncodingModes.Mode2 ;
            switch (cbEncoding.SelectedIndex)
            {
                case 0:
                    encodingMode = EncodingModes.Mode2;
                    break;
                case 1:
                    encodingMode = EncodingModes.Mode3;
                    break;
                case 2:
                    encodingMode = EncodingModes.Mode4;
                    break;
                case 3:
                    encodingMode = EncodingModes.Mode5;
                    break;
                case 4:
                    encodingMode = EncodingModes.Mode6;
                    break;
            }



            MaxiCode MaxiCode = new MaxiCode();
            byte[] raster = null;
            String vector = "";
            String encodedText = "";

            webCode.Visible = false;
            picCode.Visible = false;
            lblCode.Visible = false;

            if (cmbOutput.SelectedIndex == 2) // BMP raster image output
            {
                raster = MaxiCode.EncodeMaxiCode(dataToEncode, applyTilde, encodingMode, QuietZone, DotPM);
                picCode.AutoSize = true;
                using (MemoryStream mStream = new MemoryStream(raster))
                {
                    Image img1 = Image.FromStream(mStream);
                    picCode.Image = img1;


                    // // code to produce a PNG or a GIF or other formats
                    // // **************************************************
                    //MemoryStream mStream1 = new MemoryStream(raster);
                    //Image img1 = Image.FromStream(mStream1);

                    //MemoryStream mStream2 = new MemoryStream();
                    //if ( __PNG__ ) // PNG
                    //    img1.Save(mStream2, ImageFormat.Png);
                    //else if ( __GIF__ ) // GIF
                    //    img1.Save(mStream2, ImageFormat.Gif);

                    //raster = mStream2.ToArray();
                    // // **************************************************


                }
                picCode.Visible = true;

                if (chkSaveGraphic.Checked)
                    File.WriteAllBytes("IDAutomation_MaxiCode.BMP", raster);

            }
            else if (cmbOutput.SelectedIndex == 3)
            {

                vector = MaxiCode.EncodeMaxiCode(dataToEncode, applyTilde, encodingMode, VectorTypes.VecSVG, null, QuietZone, DotPM);
                webCode.DocumentText = vector;
                webCode.Visible = true;
                if (chkSaveGraphic.Checked)
                    File.WriteAllText("IDAutomation_MaxiCode.SVG", vector);

            }
            else if (cmbOutput.SelectedIndex == 4)
            {
                vector = MaxiCode.EncodeMaxiCode(dataToEncode, applyTilde, encodingMode, VectorTypes.VecHTML, null, QuietZone, DotPM);
                webCode.DocumentText = vector;
                webCode.Visible = true;
                if (chkSaveGraphic.Checked)
                    File.WriteAllText("IDAutomation_MaxiCode.HTML", vector);
            }
            else if (cmbOutput.SelectedIndex == 5)
            {
                vector = MaxiCode.EncodeMaxiCode(dataToEncode, applyTilde, encodingMode, VectorTypes.VecEPS, null, QuietZone, DotPM);
                if (chkSaveGraphic.Checked)
                    File.WriteAllText("IDAutomation_MaxiCode.EPS", vector);
            }
            else
            {
                encodedText = MaxiCode.EncodeMaxiCode(dataToEncode, applyTilde, encodingMode, null);
                if (cmbOutput.SelectedIndex == 0)
                {
                    lblCode.Font = new System.Drawing.Font("Courier New", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                }
                else if (cmbOutput.SelectedIndex == 1)
                {
                    lblCode.Font = new System.Drawing.Font("IDAutomation Maxicode", 14.5F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                }
                lblCode.Text = encodedText;
                lblCode.Visible = true;
            }
        }

        private void cmbOutput_SelectedIndexChanged(object sender, EventArgs e)
        {
            txtQuietZone.Enabled = (cmbOutput.SelectedIndex >= 2);
            chkSaveGraphic.Enabled = (cmbOutput.SelectedIndex >= 2);
            cmbDotpMM.Enabled = (cmbOutput.SelectedIndex >= 2);
        }

        private void button1_Click(object sender, EventArgs e)
        {

            TabTest frm2 = new TabTest();
            frm2.ShowDialog();
        }

        private void chkSaveGraphic_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void label5_Click(object sender, EventArgs e)
        {

        }
    }


}
