//  Copyright, 2020 IDAutomation.com, Inc. All rights reserved. Patent Pending
// Redistribution and use of this code in source and/or binary 
// forms, with or without modification, are permitted provided 
// that: (1) all copies of the source code retain the above 
// unmodified copyright notice and this entire unmodified 
// section of text, (2) You or Your organization owns a valid 
// Developer License to this product from IDAutomation.com 
// and, (3) when any portion of this code is bundled in any 
// form with an application, a valid notice must be provided 
// within the user documentation, start-up screen or in the 
// help-about section of the application that specifies 
// IDAutomation.com as the provider of the Software bundled 
// with the application.


using System.Windows.Forms;
//<exclude/>
namespace TestQR_GUI
{
    /// <summary>
    /// Summary description for frmDemo.
    /// </summary>
    // <exclude/>
    public partial class frmDemo : Form
	{
		private System.Windows.Forms.Label lblDemo;
		private System.Windows.Forms.LinkLabel lnkBuyProduct;
		private System.Windows.Forms.Button cmdClose;
		private System.Windows.Forms.PictureBox pictureBox2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
/// <summary>
/// Demo Form
/// </summary>
		public frmDemo()
		{
			InitializeComponent();
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(frmDemo));
            this.lnkBuyProduct = new System.Windows.Forms.LinkLabel();
            this.lblDemo = new System.Windows.Forms.Label();
            this.cmdClose = new System.Windows.Forms.Button();
            this.pictureBox2 = new System.Windows.Forms.PictureBox();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox2)).BeginInit();
            this.SuspendLayout();
            // 
            // lnkBuyProduct
            // 
            this.lnkBuyProduct.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lnkBuyProduct.Location = new System.Drawing.Point(142, 178);
            this.lnkBuyProduct.Name = "lnkBuyProduct";
            this.lnkBuyProduct.Size = new System.Drawing.Size(232, 16);
            this.lnkBuyProduct.TabIndex = 1;
            this.lnkBuyProduct.TabStop = true;
            this.lnkBuyProduct.Text = "http://www.idautomation.com/";
            this.lnkBuyProduct.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.lnkBuyProduct_LinkClicked);
            // 
            // lblDemo
            // 
            this.lblDemo.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblDemo.Location = new System.Drawing.Point(0, 64);
            this.lblDemo.Name = "lblDemo";
            this.lblDemo.Size = new System.Drawing.Size(465, 114);
            this.lblDemo.TabIndex = 1;
            this.lblDemo.Text = "Label1";
            this.lblDemo.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // cmdClose
            // 
            this.cmdClose.BackColor = System.Drawing.Color.LightGray;
            this.cmdClose.Location = new System.Drawing.Point(197, 202);
            this.cmdClose.Name = "cmdClose";
            this.cmdClose.Size = new System.Drawing.Size(80, 22);
            this.cmdClose.TabIndex = 0;
            this.cmdClose.Text = "&Close";
            this.cmdClose.UseVisualStyleBackColor = false;
            this.cmdClose.Click += new System.EventHandler(this.cmdClose_Click);
            // 
            // pictureBox2
            // 
            this.pictureBox2.Cursor = System.Windows.Forms.Cursors.Hand;
            this.pictureBox2.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox2.Image")));
            this.pictureBox2.Location = new System.Drawing.Point(3, 0);
            this.pictureBox2.Name = "pictureBox2";
            this.pictureBox2.Size = new System.Drawing.Size(464, 56);
            this.pictureBox2.SizeMode = System.Windows.Forms.PictureBoxSizeMode.CenterImage;
            this.pictureBox2.TabIndex = 7;
            this.pictureBox2.TabStop = false;
            // 
            // frmDemo
            // 
            this.BackColor = System.Drawing.SystemColors.Control;
            this.ClientSize = new System.Drawing.Size(470, 233);
            this.ControlBox = false;
            this.Controls.Add(this.pictureBox2);
            this.Controls.Add(this.cmdClose);
            this.Controls.Add(this.lblDemo);
            this.Controls.Add(this.lnkBuyProduct);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "frmDemo";
            this.Text = "IDAutomation.com MaxiCode Demo";
            this.Load += new System.EventHandler(this.frmDemo_Load);
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox2)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion		

		private void frmDemo_Load(object sender, System.EventArgs e)
		{

    		this.Text = "IDAutomation.com MaxiCode Barcode Demo";
            lnkBuyProduct.Links.Add(0, 64, "http://www.idautomation.com");
            lblDemo.Text = "The demo version of this product is only an example that generates a static barcode that cannot be changed. "
                + (char) 10 + (char) 10 + " A working demo of this product is not provided, because that would reveal the complete source code, which is only available in the licensed version. The licensed version is available at " ;
		}

		private void cmdClose_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void lnkBuyProduct_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			try
			{
				// Determine which link was clicked within the LinkLabel.
				lnkBuyProduct.Links[lnkBuyProduct.Links.IndexOf(e.Link)].Visited = true;
				
				// Display the appropriate link based on the value of the LinkData property of the Link object.
				System.Diagnostics.Process.Start(e.Link.LinkData.ToString());
			}
			catch
			{
				MessageBox.Show(this, "Please visit http://www.idautomation.com to order this product.", "Site Visit", MessageBoxButtons.OK, MessageBoxIcon.Information);
			}		
		}
	}
}
