﻿using System;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;
using IDAutomation.NetStandard.MaxiCode.FontEncoder;
using System.Collections.Generic;
using System.IO;

namespace XamarinTest
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class MaxiCodePage : ContentPage

         
    {

        MaxiCode mx = new MaxiCode(); //local instance
        Label mxcode = new Label { };
        Editor editor = new Editor { };
        Image image = new Image { };

        // Dictionary for font picker.
        Dictionary<string, int> outputMode = new Dictionary<string, int>
        {
            { "IDAutomation Maxicode Font", 0 }, { "BMP Image ", 1 }
        };

        Picker picker = new Picker
        {
            Title = "Output mode",
            VerticalOptions = LayoutOptions.CenterAndExpand
        };



        public MaxiCodePage()
        {

            var layout = new StackLayout { Padding = new Thickness(5, 5) };
            this.Content = layout;
            editor.Text = "IDAutomation .Net Standard 2";
            layout.Children.Add(editor);

            foreach (string outputType in outputMode.Keys)
            {
                picker.Items.Add(outputType);
            }
            picker.SelectedIndex = 0;
            layout.Children.Add(picker);


            mxcode.FontFamily = Device.RuntimePlatform == Device.iOS ? "IDAutomation Maxicode" :
                                   Device.RuntimePlatform == Device.Android ? "IDAutomationMaxicode.ttf#IDAutomation Maxicode" : "Assets/IDAutomationMaxicode.ttf#IDAutomation Maxicode";
            mxcode.TextColor = Color.Black;
            mxcode.VerticalOptions = LayoutOptions.Center;
            mxcode.HorizontalOptions = LayoutOptions.Center;
            mxcode.FontSize = Device.RuntimePlatform == Device.iOS ? 18 :
                Device.RuntimePlatform == Device.Android ? Device.GetNamedSize(NamedSize.Medium, mxcode) : Device.GetNamedSize(NamedSize.Large, mxcode);
            layout.Children.Add(mxcode);

            image.BackgroundColor = Color.White;
            image.VerticalOptions = LayoutOptions.Center;
            image.HorizontalOptions = LayoutOptions.Center;
            image.IsVisible = false;
            layout.Children.Add(image);



            Button button = new Button
            {
                Text = "Apply",
                VerticalOptions = LayoutOptions.CenterAndExpand,
                HorizontalOptions = LayoutOptions.Center
            };
            button.Clicked += apply;
            layout.Children.Add(button);

        }

        void apply(object sender, EventArgs e)
        {
            if (picker.SelectedIndex == 0)
            {
                mxcode.IsVisible = true;
                image.IsVisible = false;

                mxcode.FontFamily = Device.RuntimePlatform == Device.iOS ? "IDAutomation Maxicode" :
                                       Device.RuntimePlatform == Device.Android ? "IDAutomationMaxicode.ttf#IDAutomation Maxicode" : "Assets/IDAutomationMaxicode.ttf#IDAutomation Maxicode";
                mxcode.FontSize = Device.RuntimePlatform == Device.iOS ? 18 :
                    Device.RuntimePlatform == Device.Android ? Device.GetNamedSize(NamedSize.Default, mxcode) : Device.GetNamedSize(NamedSize.Medium, mxcode);
                mxcode.Text = mx.EncodeMaxiCode(editor.Text, true, EncodingModes.Mode2, null);
            }
            else

            {
                image.IsVisible = true;
                mxcode.IsVisible = false;
                image.Source = ImageSource.FromStream(() => new MemoryStream(mx.EncodeMaxiCode(editor.Text, true, EncodingModes.Mode2, 1, 16)));
            }


        }
    }
}

