﻿Imports System.IO

Public Class TabTest
    Public Sub New()

        ' La chiamata è richiesta dalla finestra di progettazione.
        InitializeComponent()

        cmbMode.SelectedIndex = 1

    End Sub

    Private Sub TestTab()

        Dim MX As New MaxiCode
        Dim encodedText As String = ""
        Dim dataToEncode As String = ""
        Dim applyTilde As Boolean = True '' use ~ for special encoding
        Dim encodingMode As EncodingModes = EncodingModes.Mode2
        Dim raster() As Byte
        Dim vector As String

        Dim testData() As String = {"[)>~03001~02996336091062~029840~029002~0291Z14647438~029UPSN~029410E1W~029195~029~0291/1~029~029Y~029135Reo~029TAMPA~029FL~030~004",
                                    "[)>~03001~029961Z00004951~029UPSN~02906X610~029159~0291234567~0291/1~029~029Y~029634 ALPHA DR~029PITTSBURGH~029PA~030~004",
                                    "[)>~03001~02996336091062~029840~029002~0299Z94647438~029UPSN~029410E1W~029195~029~0291/1~029~029Y~029550 North Cypress Point Way~029TAMPA~029FL~030~004",
                                    "[)>~03001~02996336297224~029840~029003~0291Z06393640~029UPSN~029750Y1E~03007VI3%S%QCMH:7HQVE'483/5~028EL..EF+&O(0CYAY~029""%H(J~010~030~004",
                                    "[)>~03001~029961Z00136111~029UPSN~029123X56~029057~029~029001/001~029011~029N~029~029 WEST SWINDON~029~030~004",
                                    "MODE 4 MAX DATA TEST. THE QUICK BROWN FOX JUMPS OVER THE LAZY DOG. THE QUICK BROWN FOX JUMPS.",
                                    "Mode 4 Max Data test. The quick brown fox jumps over the lazy dog. The quick brown fox",
                                    "MODE 5 MAX DATA TEST. THE QUICK BROWN FOX JUMPS OVER THE LAZY DOG. THE QUICK",
                                    "Mode 5 Max Data test. The quick brown fox jumps over the lazy dog.",
                                    "[)>~03001~02996336091062~029840~029002~0291Z9999999999999999~029UPSN~029410E1W~029195~029~0291/1~029~029Y~0295500 CYPRESS PT DR~029BRADENTO~029FL~030~004",
                                    "[)>~03001~02996336091062~029840~029002~0291Z9999999999999999~029UPSN~029410E1W~029195~029~0291/1~029~029Y~0295500 CYPRESS PT DR~029BRADENTON~029FL~030~004"
                                   }

        Dim testMode() As Integer = {2, 2, 2, 2, 3, 4, 4, 5, 5, 2, 2}

        Dim i As Integer
        For i = 0 To testData.Length() - 1
            dataToEncode = testData(i)

            Select Case testMode(i)
                Case 2
                    encodingMode = EncodingModes.Mode2
                Case 3
                    encodingMode = EncodingModes.Mode3
                Case 4
                    encodingMode = EncodingModes.Mode4
                Case 5
                    encodingMode = EncodingModes.Mode5
                Case Else
                    encodingMode = EncodingModes.Mode2

            End Select

            If (cmbMode.SelectedIndex = 2) Then '' BMP Then raster image output
                raster = MX.EncodeMaxiCode(dataToEncode, applyTilde, encodingMode, 1, 16)
            ElseIf (cmbMode.SelectedIndex = 3) Then
                vector = MX.EncodeMaxiCode(dataToEncode, applyTilde, encodingMode, VectorTypes.VecSVG, vbCrLf, 1, 16)
            ElseIf (cmbMode.SelectedIndex = 4) Then
                vector = MX.EncodeMaxiCode(dataToEncode, applyTilde, encodingMode, VectorTypes.VecHTML, vbCrLf, 1, 16)
            ElseIf (cmbMode.SelectedIndex < 2) Then
                encodedText = MX.EncodeMaxiCode(dataToEncode, applyTilde, encodingMode, "")
            End If
            renderBarcodeToTab("MaxiCode" + (i + 1).ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector)

            If (chkSaveEPS.Checked) Then
                vector = MX.EncodeMaxiCode(dataToEncode, applyTilde, encodingMode, VectorTypes.VecEPS, "", 1, 16)
                File.WriteAllText("MaxiCode" + (i + 1).ToString() + ".EPS", vector)
            End If
        Next

        ' ****************************************************************************************************************************************************


    End Sub


    Private Sub renderBarcodeToTab(tabName As String, dataToEncode As String, encodingMode As String, encodedText As String, raster As Byte(), vector As String)

        Dim LL As Integer = 20
        Dim LTOP As Integer = 10
        Dim YSpacing As Integer = 10


        Dim tp As New TabPage(tabName)
        tp.Font = New System.Drawing.Font("Consolas", 10.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, 0)
        tp.AutoScroll = True ''allow scrolling to fit output
        TabControl1.TabPages.Add(tp) ''add tab to page

        '' TOP - LEFT
        Dim showDTEText As New Label
        showDTEText.Name = "showDTEText"
        showDTEText.Location = New System.Drawing.Point(LL, LTOP)
        showDTEText.AutoSize = True
        showDTEText.Text = "DATA ENCODED: "
        showDTEText.Font = New System.Drawing.Font("Microsoft Sans Serif", 10.0F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, 0)
        tp.Controls.Add(showDTEText)

        Dim showDTE As New Label
        showDTE.Name = "showDTE"
        showDTE.Location = New System.Drawing.Point(LL, showDTEText.Location.Y + showDTEText.Height + YSpacing)
        showDTE.AutoSize = True
        showDTE.Text = formatText(dataToEncode)
        tp.Controls.Add(showDTE)


        '' encodingMode
        Dim lblEncMode As New Label
        lblEncMode.Location = New System.Drawing.Point(LL, showDTE.Location.Y + showDTE.Height + YSpacing)
        lblEncMode.Name = "lblECM"
        lblEncMode.Size = New System.Drawing.Size(200, 13)
        lblEncMode.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, 0)
        lblEncMode.Text = "ENC MODE: " + encodingMode.ToUpper()
        tp.Controls.Add(lblEncMode)

        ''barcode
        Dim lblBarcodeTitle As New Label
        lblBarcodeTitle.AutoSize = True
        lblBarcodeTitle.Location = New System.Drawing.Point(LL, lblEncMode.Location.Y + lblEncMode.Height + YSpacing)
        lblBarcodeTitle.Name = "lblDTETitle"
        ''lblBarcodeTitle.Size = New System.Drawing.Size(83, 13)
        lblBarcodeTitle.Text = "BARCODE:"
        lblBarcodeTitle.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, 0)
        tp.Controls.Add(lblBarcodeTitle)

        Dim lblBarcode As New Label
        lblBarcode.AutoSize = True
        lblBarcode.Location = New System.Drawing.Point(LL, lblBarcodeTitle.Location.Y + lblBarcodeTitle.Height + YSpacing)
        lblBarcode.Name = "lblBarcodeBox"
        lblBarcode.Text = encodedText

        If (cmbMode.SelectedIndex = 0) Then
            lblBarcode.Font = New System.Drawing.Font("Courier New", 8.5F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, 0)
            tp.Controls.Add(lblBarcode)
        ElseIf (cmbMode.SelectedIndex = 1) Then
            lblBarcode.Font = New System.Drawing.Font("IDAutomation MaxiCode", 14.5F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, 0)
            tp.Controls.Add(lblBarcode)

            ''encoded data
            Dim lblEncDataTitle As New Label
            lblEncDataTitle.AutoSize = True
            lblEncDataTitle.Location = New System.Drawing.Point(LL, lblBarcode.Location.Y + lblBarcode.Height + YSpacing)
            lblEncDataTitle.Name = "lblDTETitle"
            ''lblEncDataTitle.Size = New System.Drawing.Size(83, 13)
            lblEncDataTitle.Text = "ENCODED RESULT:"
            lblEncDataTitle.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, 0)
            tp.Controls.Add(lblEncDataTitle)

            Dim lblEncData = New Label
            lblEncData.Location = New System.Drawing.Point(LL, lblEncDataTitle.Location.Y + lblEncDataTitle.Height + YSpacing)
            lblEncData.Name = "lblEncData"
            lblEncData.AutoSize = True
            lblEncData.Text = encodedText
            tp.Controls.Add(lblEncData)

        ElseIf (cmbMode.SelectedIndex = 2) Then
            Dim picImage As PictureBox = New PictureBox()
            picImage.AutoSize = True
            picImage.Location = New System.Drawing.Point(LL, lblBarcodeTitle.Location.Y + lblBarcodeTitle.Height + YSpacing)
            picImage.Name = "picCode"
            Dim mStream As MemoryStream = New MemoryStream(raster)
            Dim img1 As Image = Image.FromStream(mStream)
            picImage.Image = img1
            tp.Controls.Add(picImage)

        ElseIf (cmbMode.SelectedIndex = 3 Or cmbMode.SelectedIndex = 4) Then
            Dim WebBrowser As WebBrowser = New WebBrowser()
            WebBrowser.Location = New System.Drawing.Point(LL, lblBarcodeTitle.Location.Y + lblBarcodeTitle.Height + YSpacing)
            WebBrowser.Width = tp.Width - WebBrowser.Left
            WebBrowser.Height = tp.Height - WebBrowser.Top
            WebBrowser.Anchor = AnchorStyles.Top Or AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Bottom
            WebBrowser.DocumentText = vector
            tp.Controls.Add(WebBrowser)

        End If




    End Sub


    Private Function formatText(inText As String) As String
        Dim maxWidth As Integer = 175 '' width Of text shown In window
        Dim formattedString As String = ""

        For i = 0 To inText.Length - 1 Step maxWidth
            formattedString += SafeSubstring(inText, i, maxWidth) + Environment.NewLine
        Next

        formatText = formattedString
    End Function

    Private Function SafeSubstring(value As String, startIndex As Integer, length As Integer) As String
        If (value <> "") Then
            If (value.Length - startIndex) < length Then length = value.Length - startIndex
            value = value.Substring(startIndex, length)
        End If
        SafeSubstring = value
    End Function

    Private Sub chkSaveEPS_CheckedChanged(sender As Object, e As EventArgs) Handles chkSaveEPS.CheckedChanged
        TabControl1.TabPages.Clear()
        TestTab()
    End Sub

    Private Sub cmbMode_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cmbMode.SelectedIndexChanged
        TabControl1.TabPages.Clear()
        TestTab()
    End Sub
End Class
